Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4268)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4270)
@@ -11967,3 +12105,981 @@
  END FUNCTION
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Set the lateral and top boundary conditions in case the PALM domain is
+!> nested offline in a mesoscale model. Further, average boundary data and
+!> determine mean profiles, further used for correct damping in the sponge
+!> layer.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_nesting_offl_bc
+
+    USE control_parameters,                                                                        &
+        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, dt_3d,              &
+               time_since_reference_point
+
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nxl, nxr, nyn, nys, nzb, nzt
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i    !< running index x-direction
+    INTEGER(iwp) ::  ib   !< running index for aerosol number bins
+    INTEGER(iwp) ::  ic   !< running index for aerosol mass bins
+    INTEGER(iwp) ::  icc  !< running index for aerosol mass bins
+    INTEGER(iwp) ::  ig   !< running index for gaseous species
+    INTEGER(iwp) ::  j    !< running index y-direction
+    INTEGER(iwp) ::  k    !< running index z-direction
+
+    REAL(wp) ::  fac_dt  !< interpolation factor
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_mconc    !< reference profile for aerosol mass
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_mconc_l  !< reference profile for aerosol mass: subdomain
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_nconc    !< reference profile for aerosol number
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_nconc_l  !< reference profile for aerosol_number: subdomain
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_gconc    !< reference profile for gases
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_gconc_l  !< reference profile for gases: subdomain
+
+!
+!-- Skip input if no forcing from larger-scale models is applied.
+    IF ( .NOT. nesting_offline_salsa )  RETURN
+!
+!-- Allocate temporary arrays to compute salsa mean profiles
+    ALLOCATE( ref_gconc(nzb:nzt+1,1:ngases_salsa), ref_gconc_l(nzb:nzt+1,1:ngases_salsa),          &
+              ref_mconc(nzb:nzt+1,1:nbins_aerosol*ncomponents_mass),                               &
+              ref_mconc_l(nzb:nzt+1,1:nbins_aerosol*ncomponents_mass),                             &
+              ref_nconc(nzb:nzt+1,1:nbins_aerosol), ref_nconc_l(nzb:nzt+1,1:nbins_aerosol) )
+    ref_gconc   = 0.0_wp
+    ref_gconc_l = 0.0_wp
+    ref_mconc   = 0.0_wp
+    ref_mconc_l = 0.0_wp
+    ref_nconc   = 0.0_wp
+    ref_nconc_l = 0.0_wp
+
+!
+!-- Determine interpolation factor and limit it to 1. This is because t+dt can slightly exceed
+!-- time(tind_p) before boundary data is updated again.
+    fac_dt = ( time_since_reference_point - salsa_nest_offl%time(salsa_nest_offl%tind)  + dt_3d )  &
+             / ( salsa_nest_offl%time(salsa_nest_offl%tind_p) -                                    &
+                 salsa_nest_offl%time(salsa_nest_offl%tind) )
+    fac_dt = MIN( 1.0_wp, fac_dt )
+
+    IF ( bc_dirichlet_l )  THEN
+       DO  ib = 1, nbins_aerosol
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                aerosol_number(ib)%conc(k,j,-1) = ( 1.0_wp - fac_dt ) *                            &
+                                                  salsa_nest_offl%nconc_left(0,k,j,ib) + fac_dt *  &
+                                                  salsa_nest_offl%nconc_left(1,k,j,ib)
+             ENDDO
+             ref_nconc_l(nzb+1:nzt,ib) = ref_nconc_l(nzb+1:nzt,ib) +                               &
+                                         aerosol_number(ib)%conc(nzb+1:nzt,j,-1)
+          ENDDO
+          DO  ic = 1, ncomponents_mass
+             icc = ( ic-1 ) * nbins_aerosol + ib
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+                   aerosol_mass(icc)%conc(k,j,-1) = ( 1.0_wp - fac_dt ) *                          &
+                                                    salsa_nest_offl%mconc_left(0,k,j,icc) + fac_dt &
+                                                    * salsa_nest_offl%mconc_left(1,k,j,icc)
+                ENDDO
+                ref_mconc_l(nzb+1:nzt,icc) = ref_mconc_l(nzb+1:nzt,icc) +                          &
+                                             aerosol_mass(icc)%conc(nzb+1:nzt,j,-1)
+             ENDDO
+          ENDDO
+       ENDDO
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+          DO  ig = 1, ngases_salsa
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+                   salsa_gas(ig)%conc(k,j,-1) = ( 1.0_wp - fac_dt ) *                              &
+                                                salsa_nest_offl%gconc_left(0,k,j,ig) + fac_dt *    &
+                                                salsa_nest_offl%gconc_left(1,k,j,ig)
+                ENDDO
+                ref_gconc_l(nzb+1:nzt,ig) = ref_gconc_l(nzb+1:nzt,ig) +                            &
+                                            salsa_gas(ig)%conc(nzb+1:nzt,j,-1)
+             ENDDO
+          ENDDO
+       ENDIF
+    ENDIF
+
+    IF ( bc_dirichlet_r )  THEN
+       DO  ib = 1, nbins_aerosol
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                aerosol_number(ib)%conc(k,j,nxr+1) = ( 1.0_wp - fac_dt ) *                         &
+                                                  salsa_nest_offl%nconc_right(0,k,j,ib) + fac_dt * &
+                                                  salsa_nest_offl%nconc_right(1,k,j,ib)
+             ENDDO
+             ref_nconc_l(nzb+1:nzt,ib) = ref_nconc_l(nzb+1:nzt,ib) +                               &
+                                         aerosol_number(ib)%conc(nzb+1:nzt,j,nxr+1)
+          ENDDO
+          DO  ic = 1, ncomponents_mass
+             icc = ( ic-1 ) * nbins_aerosol + ib
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+                   aerosol_mass(icc)%conc(k,j,nxr+1) = ( 1.0_wp - fac_dt ) *                       &
+                                                    salsa_nest_offl%mconc_right(0,k,j,icc) + fac_dt&
+                                                    * salsa_nest_offl%mconc_right(1,k,j,icc)
+                ENDDO
+                ref_mconc_l(nzb+1:nzt,icc) = ref_mconc_l(nzb+1:nzt,icc) +                          &
+                                             aerosol_mass(icc)%conc(nzb+1:nzt,j,nxr+1)
+             ENDDO
+          ENDDO
+       ENDDO
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+          DO  ig = 1, ngases_salsa
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+                   salsa_gas(ig)%conc(k,j,nxr+1) = ( 1.0_wp - fac_dt ) *                           &
+                                                   salsa_nest_offl%gconc_right(0,k,j,ig) + fac_dt *&
+                                                   salsa_nest_offl%gconc_right(1,k,j,ig)
+                ENDDO
+                ref_gconc_l(nzb+1:nzt,ig) = ref_gconc_l(nzb+1:nzt,ig) +                            &
+                                            salsa_gas(ig)%conc(nzb+1:nzt,j,nxr+1)
+             ENDDO
+          ENDDO
+       ENDIF
+    ENDIF
+
+    IF ( bc_dirichlet_n )  THEN
+       DO  ib = 1, nbins_aerosol
+          DO  i = nxl, nxr
+             DO  k = nzb+1, nzt
+                aerosol_number(ib)%conc(k,nyn+1,i) = ( 1.0_wp - fac_dt ) *                         &
+                                                  salsa_nest_offl%nconc_north(0,k,i,ib) + fac_dt * &
+                                                  salsa_nest_offl%nconc_north(1,k,i,ib)
+             ENDDO
+             ref_nconc_l(nzb+1:nzt,ib) = ref_nconc_l(nzb+1:nzt,ib) +                               &
+                                         aerosol_number(ib)%conc(nzb+1:nzt,nyn+1,i)
+          ENDDO
+          DO  ic = 1, ncomponents_mass
+             icc = ( ic-1 ) * nbins_aerosol + ib
+             DO  i = nxl, nxr
+                DO  k = nzb+1, nzt
+                   aerosol_mass(icc)%conc(k,nyn+1,i) = ( 1.0_wp - fac_dt ) *                       &
+                                                    salsa_nest_offl%mconc_north(0,k,i,icc) + fac_dt&
+                                                    * salsa_nest_offl%mconc_north(1,k,i,icc)
+                ENDDO
+                ref_mconc_l(nzb+1:nzt,icc) = ref_mconc_l(nzb+1:nzt,icc) +                          &
+                                             aerosol_mass(icc)%conc(nzb+1:nzt,nyn+1,i)
+             ENDDO
+          ENDDO
+       ENDDO
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+          DO  ig = 1, ngases_salsa
+             DO  i = nxl, nxr
+                DO  k = nzb+1, nzt
+                   salsa_gas(ig)%conc(k,nyn+1,i) = ( 1.0_wp - fac_dt ) *                           &
+                                                   salsa_nest_offl%gconc_north(0,k,i,ig) + fac_dt *&
+                                                   salsa_nest_offl%gconc_north(1,k,i,ig)
+                ENDDO
+                ref_gconc_l(nzb+1:nzt,ig) = ref_gconc_l(nzb+1:nzt,ig) +                            &
+                                            salsa_gas(ig)%conc(nzb+1:nzt,nyn+1,i)
+             ENDDO
+          ENDDO
+       ENDIF
+    ENDIF
+
+    IF ( bc_dirichlet_s )  THEN
+       DO  ib = 1, nbins_aerosol
+          DO  i = nxl, nxr
+             DO  k = nzb+1, nzt
+                aerosol_number(ib)%conc(k,-1,i) = ( 1.0_wp - fac_dt ) *                            &
+                                                  salsa_nest_offl%nconc_south(0,k,i,ib) + fac_dt * &
+                                                  salsa_nest_offl%nconc_south(1,k,i,ib)
+             ENDDO
+             ref_nconc_l(nzb+1:nzt,ib) = ref_nconc_l(nzb+1:nzt,ib) +                               &
+                                         aerosol_number(ib)%conc(nzb+1:nzt,-1,i)
+          ENDDO
+          DO  ic = 1, ncomponents_mass
+             icc = ( ic-1 ) * nbins_aerosol + ib
+             DO  i = nxl, nxr
+                DO  k = nzb+1, nzt
+                   aerosol_mass(icc)%conc(k,-1,i) = ( 1.0_wp - fac_dt ) *                          &
+                                                    salsa_nest_offl%mconc_south(0,k,i,icc) + fac_dt&
+                                                    * salsa_nest_offl%mconc_south(1,k,i,icc)
+                ENDDO
+                ref_mconc_l(nzb+1:nzt,icc) = ref_mconc_l(nzb+1:nzt,icc) +                          &
+                                             aerosol_mass(icc)%conc(nzb+1:nzt,-1,i)
+             ENDDO
+          ENDDO
+       ENDDO
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+          DO  ig = 1, ngases_salsa
+             DO  i = nxl, nxr
+                DO  k = nzb+1, nzt
+                   salsa_gas(ig)%conc(k,-1,i) = ( 1.0_wp - fac_dt ) *                              &
+                                                salsa_nest_offl%gconc_south(0,k,i,ig) + fac_dt *   &
+                                                salsa_nest_offl%gconc_south(1,k,i,ig)
+                ENDDO
+                ref_gconc_l(nzb+1:nzt,ig) = ref_gconc_l(nzb+1:nzt,ig) +                            &
+                                            salsa_gas(ig)%conc(nzb+1:nzt,-1,i)
+             ENDDO
+          ENDDO
+       ENDIF
+    ENDIF
+!
+!-- Top boundary
+    DO  ib = 1, nbins_aerosol
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             aerosol_number(ib)%conc(nzt+1,j,i) = ( 1.0_wp - fac_dt ) *                            &
+                                                  salsa_nest_offl%nconc_top(0,j,i,ib) + fac_dt *   &
+                                                  salsa_nest_offl%nconc_top(1,j,i,ib)
+             ref_nconc_l(nzt+1,ib) = ref_nconc_l(nzt+1,ib) + aerosol_number(ib)%conc(nzt+1,j,i)
+          ENDDO
+       ENDDO
+       DO  ic = 1, ncomponents_mass
+          icc = ( ic-1 ) * nbins_aerosol + ib
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                aerosol_mass(icc)%conc(nzt+1,j,i) = ( 1.0_wp - fac_dt ) *                          &
+                                                    salsa_nest_offl%mconc_top(0,j,i,icc) + fac_dt *&
+                                                    salsa_nest_offl%mconc_top(1,j,i,icc)
+                ref_mconc_l(nzt+1,icc) = ref_mconc_l(nzt+1,icc) + aerosol_mass(icc)%conc(nzt+1,j,i)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                salsa_gas(ig)%conc(nzt+1,j,i) = ( 1.0_wp - fac_dt ) *                              &
+                                                salsa_nest_offl%gconc_top(0,j,i,ig) + fac_dt *     &
+                                                salsa_nest_offl%gconc_top(1,j,i,ig)
+                ref_gconc_l(nzt+1,ig) = ref_gconc_l(nzt+1,ig) + salsa_gas(ig)%conc(nzt+1,j,i)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+!
+!-- Do local exchange
+    DO  ib = 1, nbins_aerosol
+       CALL exchange_horiz( aerosol_number(ib)%conc, nbgp )
+       DO  ic = 1, ncomponents_mass
+          icc = ( ic-1 ) * nbins_aerosol + ib
+          CALL exchange_horiz( aerosol_mass(icc)%conc, nbgp )
+       ENDDO
+    ENDDO
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          CALL exchange_horiz( salsa_gas(ig)%conc, nbgp )
+       ENDDO
+    ENDIF
+!
+!-- In case of Rayleigh damping, where the initial profiles are still used, update these profiles
+!-- from the averaged boundary data. But first, average these data.
+#if defined( __parallel )
+    IF ( .NOT. salsa_gases_from_chem )                                                             &
+       CALL MPI_ALLREDUCE( ref_gconc_l, ref_gconc, ( nzt+1-nzb+1 ) * SIZE( ref_gconc(nzb,:) ),     &
+                           MPI_REAL, MPI_SUM, comm2d, ierr )
+    CALL MPI_ALLREDUCE( ref_mconc_l, ref_mconc, ( nzt+1-nzb+1 ) * SIZE( ref_mconc(nzb,:) ),        &
+                        MPI_REAL, MPI_SUM, comm2d, ierr )
+    CALL MPI_ALLREDUCE( ref_nconc_l, ref_nconc, ( nzt+1-nzb+1 ) * SIZE( ref_nconc(nzb,:) ),        &
+                        MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+    IF ( .NOT. salsa_gases_from_chem )  ref_gconc = ref_gconc_l
+    ref_mconc = ref_mconc_l
+    ref_nconc = ref_nconc_l
+#endif
+!
+!-- Average data. Note, reference profiles up to nzt are derived from lateral boundaries, at the
+!-- model top it is derived from the top boundary. Thus, number of input data is different from
+!-- nzb:nzt compared to nzt+1.
+!-- Derived from lateral boundaries.
+    IF ( .NOT. salsa_gases_from_chem )                                                             &
+       ref_gconc(nzb:nzt,:) = ref_gconc(nzb:nzt,:) / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), KIND = wp )
+    ref_mconc(nzb:nzt,:) = ref_mconc(nzb:nzt,:) / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), KIND = wp )
+    ref_nconc(nzb:nzt,:) = ref_nconc(nzb:nzt,:) / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), KIND = wp )
+!
+!-- Derived from top boundary
+    IF ( .NOT. salsa_gases_from_chem )                                                             &
+       ref_gconc(nzt+1,:) = ref_gconc(nzt+1,:) / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
+    ref_mconc(nzt+1,:) = ref_mconc(nzt+1,:) / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
+    ref_nconc(nzt+1,:) = ref_nconc(nzt+1,:) / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
+!
+!-- Write onto init profiles, which are used for damping. Also set lower boundary condition.
+    DO  ib = 1, nbins_aerosol
+       aerosol_number(ib)%init(:)   = ref_nconc(:,ib)
+       aerosol_number(ib)%init(nzb) = aerosol_number(ib)%init(nzb+1)
+       DO  ic = 1, ncomponents_mass
+          icc = ( ic-1 ) * nbins_aerosol + ib
+          aerosol_mass(icc)%init(:)   = ref_mconc(:,icc)
+          aerosol_mass(icc)%init(nzb) = aerosol_mass(icc)%init(nzb+1)
+       ENDDO
+    ENDDO
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          salsa_gas(ig)%init(:)   = ref_gconc(:,ig)
+          salsa_gas(ig)%init(nzb) = salsa_gas(ig)%init(nzb+1)
+       ENDDO
+    ENDIF
+
+    DEALLOCATE( ref_gconc, ref_gconc_l, ref_mconc, ref_mconc_l, ref_nconc, ref_nconc_l )
+
+ END SUBROUTINE salsa_nesting_offl_bc
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Allocate arrays used to read boundary data from NetCDF file and initialize
+!> boundary data.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_nesting_offl_init
+
+    USE control_parameters,                                                                        &
+        ONLY:  end_time, initializing_actions, spinup_time
+
+    USE palm_date_time_mod,                                                                        &
+        ONLY:  get_date_time
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  ib          !< running index for aerosol number bins
+    INTEGER(iwp) ::  ic          !< running index for aerosol mass bins
+    INTEGER(iwp) ::  icc         !< additional running index for aerosol mass bins
+    INTEGER(iwp) ::  ig          !< running index for gaseous species
+    INTEGER(iwp) ::  nmass_bins  !< number of aerosol mass bins
+
+    nmass_bins = nbins_aerosol * ncomponents_mass
+!
+!-- Get time_utc_init from origin_date_time
+    CALL get_date_time( 0.0_wp, second_of_day = time_utc_init )
+!
+!-- Allocate arrays for reading boundary values. Arrays will incorporate 2 time levels in order to
+!-- interpolate in between.
+    IF ( nesting_offline_salsa )  THEN
+       IF ( bc_dirichlet_l )  THEN
+          ALLOCATE( salsa_nest_offl%nconc_left(0:1,nzb+1:nzt,nys:nyn,1:nbins_aerosol) )
+          ALLOCATE( salsa_nest_offl%mconc_left(0:1,nzb+1:nzt,nys:nyn,1:nmass_bins) )
+       ENDIF
+       IF ( bc_dirichlet_r )  THEN
+          ALLOCATE( salsa_nest_offl%nconc_right(0:1,nzb+1:nzt,nys:nyn,1:nbins_aerosol) )
+          ALLOCATE( salsa_nest_offl%mconc_right(0:1,nzb+1:nzt,nys:nyn,1:nmass_bins) )
+       ENDIF
+       IF ( bc_dirichlet_n )  THEN
+          ALLOCATE( salsa_nest_offl%nconc_north(0:1,nzb+1:nzt,nxl:nxr,1:nbins_aerosol) )
+          ALLOCATE( salsa_nest_offl%mconc_north(0:1,nzb+1:nzt,nxl:nxr,1:nmass_bins) )
+       ENDIF
+       IF ( bc_dirichlet_s )  THEN
+          ALLOCATE( salsa_nest_offl%nconc_south(0:1,nzb+1:nzt,nxl:nxr,1:nbins_aerosol) )
+          ALLOCATE( salsa_nest_offl%mconc_south(0:1,nzb+1:nzt,nxl:nxr,1:nmass_bins) )
+       ENDIF
+       ALLOCATE( salsa_nest_offl%nconc_top(0:1,nys:nyn,nxl:nxr,1:nbins_aerosol) )
+       ALLOCATE( salsa_nest_offl%mconc_top(0:1,nys:nyn,nxl:nxr,1:nmass_bins) )
+
+       IF ( .NOT. salsa_gases_from_chem )  THEN
+          IF ( bc_dirichlet_l )  THEN
+             ALLOCATE( salsa_nest_offl%gconc_left(0:1,nzb+1:nzt,nys:nyn,1:ngases_salsa) )
+          ENDIF
+          IF ( bc_dirichlet_r )  THEN
+             ALLOCATE( salsa_nest_offl%gconc_right(0:1,nzb+1:nzt,nys:nyn,1:ngases_salsa) )
+          ENDIF
+          IF ( bc_dirichlet_n )  THEN
+             ALLOCATE( salsa_nest_offl%gconc_north(0:1,nzb+1:nzt,nxl:nxr,1:ngases_salsa) )
+          ENDIF
+          IF ( bc_dirichlet_s )  THEN
+             ALLOCATE( salsa_nest_offl%gconc_south(0:1,nzb+1:nzt,nxl:nxr,1:ngases_salsa) )
+          ENDIF
+          ALLOCATE( salsa_nest_offl%gconc_top(0:1,nys:nyn,nxl:nxr,1:ngases_salsa) )
+       ENDIF
+
+!
+!--    Read data at lateral and top boundaries from a larger-scale model
+       CALL salsa_nesting_offl_input
+!
+!--    Check if sufficient time steps are provided to cover the entire simulation. Note, dynamic
+!--    input is only required for the 3D simulation, not for the soil/wall spinup. However, as the
+!--    spinup time is added to the end_time, this must be considered here.
+       IF ( end_time - spinup_time >                                           &
+            salsa_nest_offl%time(salsa_nest_offl%nt-1) - time_utc_init )  THEN
+          message_string = 'end_time of the simulation exceeds the time dimension in the dynamic'//&
+                           ' input file.'
+          CALL message( 'salsa_nesting_offl_init', 'PA0681', 1, 2, 0, 6, 0 ) 
+       ENDIF
+
+       IF ( salsa_nest_offl%time(0) /= time_utc_init )  THEN
+          message_string = 'Offline nesting: time dimension must start at time_utc_init.'
+          CALL message( 'salsa_nesting_offl_init', 'PA0682', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    Initialize boundary data. Please note, do not initialize boundaries in case of restart runs.
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.  read_restart_data_salsa )  &
+       THEN
+          IF ( bc_dirichlet_l )  THEN
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(nzb+1:nzt,nys:nyn,-1) =                                    &
+                                                 salsa_nest_offl%nconc_left(0,nzb+1:nzt,nys:nyn,ib)
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(nzb+1:nzt,nys:nyn,-1) =                                  &
+                                                 salsa_nest_offl%mconc_left(0,nzb+1:nzt,nys:nyn,icc)
+                ENDDO
+             ENDDO
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc(nzb+1:nzt,nys:nyn,-1) =                                         &
+                                                 salsa_nest_offl%gconc_left(0,nzb+1:nzt,nys:nyn,ig)
+             ENDDO
+          ENDIF
+          IF ( bc_dirichlet_r )  THEN
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(nzb+1:nzt,nys:nyn,nxr+1) =                                 &
+                                                salsa_nest_offl%nconc_right(0,nzb+1:nzt,nys:nyn,ib)
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(nzb+1:nzt,nys:nyn,nxr+1) =                               &
+                                                salsa_nest_offl%mconc_right(0,nzb+1:nzt,nys:nyn,icc)
+                ENDDO
+             ENDDO
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc(nzb+1:nzt,nys:nyn,nxr+1) =                                      &
+                                                 salsa_nest_offl%gconc_right(0,nzb+1:nzt,nys:nyn,ig)
+             ENDDO
+          ENDIF
+          IF ( bc_dirichlet_n )  THEN
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(nzb+1:nzt,nyn+1,nxl:nxr) =                                 &
+                                                salsa_nest_offl%nconc_north(0,nzb+1:nzt,nxl:nxr,ib)
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(nzb+1:nzt,nyn+1,nxl:nxr) =                               &
+                                                salsa_nest_offl%mconc_north(0,nzb+1:nzt,nxl:nxr,icc)
+                ENDDO
+             ENDDO
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc(nzb+1:nzt,nyn+1,nxl:nxr) =                                      &
+                                                 salsa_nest_offl%gconc_north(0,nzb+1:nzt,nxl:nxr,ig)
+             ENDDO
+          ENDIF
+          IF ( bc_dirichlet_s )  THEN
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(nzb+1:nzt,-1,nxl:nxr) =                                    &
+                                                salsa_nest_offl%nconc_south(0,nzb+1:nzt,nxl:nxr,ib)
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic - 1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(nzb+1:nzt,-1,nxl:nxr) =                                  &
+                                                salsa_nest_offl%mconc_south(0,nzb+1:nzt,nxl:nxr,icc)
+                ENDDO
+             ENDDO
+             DO  ig = 1, ngases_salsa
+                salsa_gas(ig)%conc(nzb+1:nzt,-1,nxl:nxr) =                                         &
+                                                 salsa_nest_offl%gconc_south(0,nzb+1:nzt,nxl:nxr,ig)
+             ENDDO
+          ENDIF
+       ENDIF
+    ENDIF
+
+ END SUBROUTINE salsa_nesting_offl_init
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Set the lateral and top boundary conditions in case the PALM domain is
+!> nested offline in a mesoscale model. Further, average boundary data and
+!> determine mean profiles, further used for correct damping in the sponge
+!> layer.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_nesting_offl_input
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
+               inquire_num_variables, inquire_variable_names,                                      &
+               get_dimension_length, open_read_file
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=25) ::  vname  !< variable name
+
+    INTEGER(iwp) ::  ic        !< running index for aerosol chemical components
+    INTEGER(iwp) ::  ig        !< running index for gases
+    INTEGER(iwp) ::  num_vars  !< number of variables in netcdf input file
+
+!
+!-- Skip input if no forcing from larger-scale models is applied.
+    IF ( .NOT. nesting_offline_salsa )  RETURN
+!
+!-- Initialise
+    IF ( .NOT. salsa_nest_offl%init )  THEN
+
+#if defined ( __netcdf )
+!
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_dynamic ) // TRIM( coupling_char ),                   &
+                            salsa_nest_offl%id_dynamic )
+!
+!--    At first, inquire all variable names.
+       CALL inquire_num_variables( salsa_nest_offl%id_dynamic, num_vars )
+!
+!--    Allocate memory to store variable names.
+       ALLOCATE( salsa_nest_offl%var_names(1:num_vars) )
+       CALL inquire_variable_names( salsa_nest_offl%id_dynamic, salsa_nest_offl%var_names )
+!
+!--    Read time dimension, allocate memory and finally read time array
+       CALL get_dimension_length( salsa_nest_offl%id_dynamic, salsa_nest_offl%nt,&
+                                                    'time' )
+
+       IF ( check_existence( salsa_nest_offl%var_names, 'time' ) )  THEN
+          ALLOCATE( salsa_nest_offl%time(0:salsa_nest_offl%nt-1) )
+          CALL get_variable( salsa_nest_offl%id_dynamic, 'time', salsa_nest_offl%time )
+       ENDIF
+!
+!--    Read the vertical dimension
+       CALL get_dimension_length( salsa_nest_offl%id_dynamic,                    &
+                                                    salsa_nest_offl%nzu, 'z' )
+       ALLOCATE( salsa_nest_offl%zu_atmos(1:salsa_nest_offl%nzu) )
+       CALL get_variable( salsa_nest_offl%id_dynamic, 'z', salsa_nest_offl%zu_atmos )
+!
+!--    Read the number of aerosol chemical components
+       CALL get_dimension_length( salsa_nest_offl%id_dynamic,                    &
+                                                    salsa_nest_offl%ncc, 'composition_index' )
+!
+!--    Read the names of aerosol chemical components
+       CALL get_variable( salsa_nest_offl%id_dynamic, 'composition_name', salsa_nest_offl%cc_name, &
+                          salsa_nest_offl%ncc )
+!
+!--    Define the index of each chemical component in the model
+       DO  ic = 1, salsa_nest_offl%ncc
+          SELECT CASE ( TRIM( salsa_nest_offl%cc_name(ic) ) )
+             CASE ( 'H2SO4', 'SO4', 'h2so4', 'so4' )
+                salsa_nest_offl%cc_in2mod(1) = ic
+             CASE ( 'OC', 'oc' )
+                salsa_nest_offl%cc_in2mod(2) = ic
+             CASE ( 'BC', 'bc' )
+                salsa_nest_offl%cc_in2mod(3) = ic
+             CASE ( 'DU', 'du' )
+                salsa_nest_offl%cc_in2mod(4) = ic
+             CASE ( 'SS', 'ss' )
+                salsa_nest_offl%cc_in2mod(5) = ic
+             CASE ( 'HNO3', 'hno3', 'NO3', 'no3', 'NO', 'no' )
+                salsa_nest_offl%cc_in2mod(6) = ic
+             CASE ( 'NH3', 'nh3', 'NH4', 'nh4', 'NH', 'nh' )
+                salsa_nest_offl%cc_in2mod(7) = ic
+          END SELECT
+       ENDDO
+       IF ( SUM( salsa_nest_offl%cc_in2mod ) == 0 )  THEN
+          message_string = 'None of the aerosol chemical components in ' //                        &
+                           TRIM( input_file_dynamic ) // ' correspond to ones applied in SALSA.'
+          CALL message( 'salsa_mod: salsa_nesting_offl_input',                      &
+                        'PA0662', 2, 2, 0, 6, 0 )
+       ENDIF
+#endif
+    ENDIF
+!
+!-- Check if dynamic driver data input is required.
+    IF ( salsa_nest_offl%time(salsa_nest_offl%tind_p) <= MAX( time_since_reference_point, 0.0_wp)  &
+         + time_utc_init  .OR.  .NOT.  salsa_nest_offl%init )  THEN
+       CONTINUE
+!
+!-- Return otherwise
+    ELSE
+       RETURN
+    ENDIF
+!
+!-- Obtain time index for current point in time.
+    salsa_nest_offl%tind = MINLOC( ABS( salsa_nest_offl%time - ( time_utc_init +                   &
+                                        MAX( time_since_reference_point, 0.0_wp) ) ), DIM = 1 ) - 1
+    salsa_nest_offl%tind_p = salsa_nest_offl%tind + 1
+!
+!-- Open file in read-only mode
+#if defined ( __netcdf )
+
+    CALL open_read_file( TRIM( input_file_dynamic ) // TRIM( coupling_char ),                      &
+                         salsa_nest_offl%id_dynamic )
+!
+!-- Read data at the western boundary
+    CALL get_variable( salsa_nest_offl%id_dynamic, 'ls_forcing_left_aerosol',                      &
+                       salsa_nest_offl%nconc_left,                                                 &
+                       MERGE( 0, 1, bc_dirichlet_l ), MERGE( nbins_aerosol-1, 0, bc_dirichlet_l ), &
+                       MERGE( nys, 1, bc_dirichlet_l ), MERGE( nyn, 0, bc_dirichlet_l ),           &
+                       MERGE( nzb, 1, bc_dirichlet_l ), MERGE( nzt-1, 0, bc_dirichlet_l ),         &
+                       MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_l ),                         &
+                       MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_l  ) )
+    IF ( bc_dirichlet_l )  THEN
+       salsa_nest_offl%nconc_left = MAX( nclim, salsa_nest_offl%nconc_left )
+       CALL nesting_offl_aero_mass( salsa_nest_offl%tind, salsa_nest_offl%tind_p, nzb+1, nzt, nys, &
+                                    nyn, 'ls_forcing_left_mass_fracs_a', 1 )
+    ENDIF
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          vname = salsa_nest_offl%char_l // salsa_nest_offl%gas_name(ig)
+          CALL get_variable( salsa_nest_offl%id_dynamic, TRIM( vname ),                            &
+                             salsa_nest_offl%gconc_left(:,:,:,ig),                                 &
+                             MERGE( nys, 1, bc_dirichlet_l ), MERGE( nyn, 0, bc_dirichlet_l ),     &
+                             MERGE( nzb, 1, bc_dirichlet_l ), MERGE( nzt-1, 0, bc_dirichlet_l ),   &
+                             MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_l ),                   &
+                             MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_l ) )
+          IF ( bc_dirichlet_l )  salsa_nest_offl%gconc_left(:,:,:,ig) =                            &
+                                                  MAX( nclim, salsa_nest_offl%gconc_left(:,:,:,ig) )
+       ENDDO
+    ENDIF
+!
+!-- Read data at the eastern boundary
+    CALL get_variable( salsa_nest_offl%id_dynamic, 'ls_forcing_right_aerosol',                     &
+                       salsa_nest_offl%nconc_right,                                                &
+                       MERGE( 0, 1, bc_dirichlet_r ), MERGE( nbins_aerosol-1, 0, bc_dirichlet_r ), &
+                       MERGE( nys, 1, bc_dirichlet_r ), MERGE( nyn, 0, bc_dirichlet_r ),           &
+                       MERGE( nzb, 1, bc_dirichlet_r ), MERGE( nzt-1, 0, bc_dirichlet_r ),         &
+                       MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_r ),                         &
+                       MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_r ) )
+    IF ( bc_dirichlet_r )  THEN
+       salsa_nest_offl%nconc_right = MAX( nclim, salsa_nest_offl%nconc_right )
+       CALL nesting_offl_aero_mass( salsa_nest_offl%tind, salsa_nest_offl%tind_p, nzb+1, nzt, nys, &
+                                    nyn, 'ls_forcing_right_mass_fracs_a', 2 )
+    ENDIF
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          vname = salsa_nest_offl%char_r // salsa_nest_offl%gas_name(ig)
+          CALL get_variable( salsa_nest_offl%id_dynamic, TRIM( vname ),                            &
+                             salsa_nest_offl%gconc_right(:,:,:,ig),                                &
+                             MERGE( nys, 1, bc_dirichlet_r ), MERGE( nyn, 0, bc_dirichlet_r ),     &
+                             MERGE( nzb, 1, bc_dirichlet_r ), MERGE( nzt-1, 0, bc_dirichlet_r ),   &
+                             MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_r ),                   &
+                             MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_r ) )
+          IF ( bc_dirichlet_r )  salsa_nest_offl%gconc_right(:,:,:,ig) =                           &
+                                                 MAX( nclim, salsa_nest_offl%gconc_right(:,:,:,ig) )
+       ENDDO
+    ENDIF
+!
+!-- Read data at the northern boundary
+    CALL get_variable( salsa_nest_offl%id_dynamic, 'ls_forcing_north_aerosol',                     &
+                       salsa_nest_offl%nconc_north,                                                &
+                       MERGE( 0, 1, bc_dirichlet_n ), MERGE( nbins_aerosol-1, 0, bc_dirichlet_n ), &
+                       MERGE( nxl, 1, bc_dirichlet_n ), MERGE( nxr, 0, bc_dirichlet_n ),           &
+                       MERGE( nzb, 1, bc_dirichlet_n ), MERGE( nzt-1, 0, bc_dirichlet_n ),         &
+                       MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_n ),                         &
+                       MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_n ) )
+    IF ( bc_dirichlet_n )  THEN
+       salsa_nest_offl%nconc_north = MAX( nclim, salsa_nest_offl%nconc_north )
+       CALL nesting_offl_aero_mass( salsa_nest_offl%tind, salsa_nest_offl%tind_p, nzb+1, nzt, nxl, &
+                                    nxr, 'ls_forcing_north_mass_fracs_a', 3 )
+    ENDIF
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          vname = salsa_nest_offl%char_n // salsa_nest_offl%gas_name(ig)
+          CALL get_variable( salsa_nest_offl%id_dynamic, TRIM( vname ),                            &
+                             salsa_nest_offl%gconc_north(:,:,:,ig),                                &
+                             MERGE( nxl, 1, bc_dirichlet_n ), MERGE( nxr, 0, bc_dirichlet_n ),     &
+                             MERGE( nzb, 1, bc_dirichlet_n ), MERGE( nzt-1, 0, bc_dirichlet_n ),   &
+                             MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_n ),                   &
+                             MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_n ) )
+          IF ( bc_dirichlet_n )  salsa_nest_offl%gconc_north(:,:,:,ig) =                           &
+                                                 MAX( nclim, salsa_nest_offl%gconc_north(:,:,:,ig) )
+       ENDDO
+    ENDIF
+!
+!-- Read data at the southern boundary
+    CALL get_variable( salsa_nest_offl%id_dynamic, 'ls_forcing_south_aerosol',                     &
+                       salsa_nest_offl%nconc_south,                                                &
+                       MERGE( 0, 1, bc_dirichlet_s ), MERGE( nbins_aerosol-1, 0, bc_dirichlet_s ), &
+                       MERGE( nxl, 1, bc_dirichlet_s ), MERGE( nxr, 0, bc_dirichlet_s ),           &
+                       MERGE( nzb, 1, bc_dirichlet_s ), MERGE( nzt-1, 0, bc_dirichlet_s ),         &
+                       MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_s ),                         &
+                       MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_s ) )
+    IF ( bc_dirichlet_s )  THEN
+       salsa_nest_offl%nconc_south = MAX( nclim, salsa_nest_offl%nconc_south )
+       CALL nesting_offl_aero_mass( salsa_nest_offl%tind, salsa_nest_offl%tind_p, nzb+1, nzt, nxl, &
+                                    nxr, 'ls_forcing_south_mass_fracs_a', 4 )
+    ENDIF
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          vname = salsa_nest_offl%char_s // salsa_nest_offl%gas_name(ig)
+          CALL get_variable( salsa_nest_offl%id_dynamic, TRIM( vname ),                            &
+                             salsa_nest_offl%gconc_south(:,:,:,ig),                                &
+                             MERGE( nxl, 1, bc_dirichlet_s ), MERGE( nxr, 0, bc_dirichlet_s ),     &
+                             MERGE( nzb, 1, bc_dirichlet_s ), MERGE( nzt-1, 0, bc_dirichlet_s ),   &
+                             MERGE( salsa_nest_offl%tind,   1, bc_dirichlet_s ),                   &
+                             MERGE( salsa_nest_offl%tind_p, 0, bc_dirichlet_s ) )
+          IF ( bc_dirichlet_s )  salsa_nest_offl%gconc_south(:,:,:,ig) =                           &
+                                                 MAX( nclim, salsa_nest_offl%gconc_south(:,:,:,ig) )
+       ENDDO
+    ENDIF
+!
+!-- Read data at the top boundary
+    CALL get_variable( salsa_nest_offl%id_dynamic, 'ls_forcing_top_aerosol',                       &
+                       salsa_nest_offl%nconc_top(0:1,nys:nyn,nxl:nxr,1:nbins_aerosol),             &
+                       0, nbins_aerosol-1, nxl, nxr, nys, nyn, salsa_nest_offl%tind,               &
+                       salsa_nest_offl%tind_p )
+    salsa_nest_offl%nconc_top = MAX( nclim, salsa_nest_offl%nconc_top )
+    CALL nesting_offl_aero_mass( salsa_nest_offl%tind, salsa_nest_offl%tind_p, nys, nyn, nxl, nxr, &
+                                 'ls_forcing_top_mass_fracs_a', 5 )
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  ig = 1, ngases_salsa
+          vname = salsa_nest_offl%char_t // salsa_nest_offl%gas_name(ig)
+          CALL get_variable( salsa_nest_offl%id_dynamic, TRIM( vname ),                            &
+                             salsa_nest_offl%gconc_top(:,:,:,ig), nxl, nxr, nys, nyn,              &
+                             salsa_nest_offl%tind, salsa_nest_offl%tind_p )
+          salsa_nest_offl%gconc_top(:,:,:,ig) = MAX( nclim, salsa_nest_offl%gconc_top(:,:,:,ig) )
+       ENDDO
+    ENDIF
+!
+!-- Close input file
+    CALL close_input_file( salsa_nest_offl%id_dynamic )
+
+#endif
+!
+!-- Set control flag to indicate that initialization is already done
+    salsa_nest_offl%init = .TRUE.
+
+ END SUBROUTINE salsa_nesting_offl_input
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sets the mass concentrations to aerosol arrays in 2a and 2b.
+!------------------------------------------------------------------------------!
+ SUBROUTINE nesting_offl_aero_mass( ts, te, ks, ke, is, ie, varname_a, ibound )
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  get_variable
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=25) ::  varname_b  !< name for bins b
+
+    CHARACTER(LEN=*), INTENT(in) ::  varname_a  !< name for bins a
+
+    INTEGER(iwp) ::  ee                !< loop index: end
+    INTEGER(iwp) ::  i                 !< loop index
+    INTEGER(iwp) ::  ib                !< loop index
+    INTEGER(iwp) ::  ic                !< loop index
+    INTEGER(iwp) ::  k                 !< loop index
+    INTEGER(iwp) ::  ss                !< loop index: start
+    INTEGER(iwp) ::  t                 !< loop index
+    INTEGER(iwp) ::  type_so4_oc = -1  !<
+
+    INTEGER(iwp), INTENT(in) ::  ibound  !< index: 1=left, 2=right, 3=north, 4=south, 5=top
+    INTEGER(iwp), INTENT(in) ::  ie      !< loop index
+    INTEGER(iwp), INTENT(in) ::  is      !< loop index
+    INTEGER(iwp), INTENT(in) ::  ks      !< loop index
+    INTEGER(iwp), INTENT(in) ::  ke      !< loop index
+    INTEGER(iwp), INTENT(in) ::  ts      !< loop index
+    INTEGER(iwp), INTENT(in) ::  te      !< loop index
+
+    INTEGER(iwp), DIMENSION(maxspec) ::  cc_i2m   !<
+
+    REAL(wp) ::  pmf1a !< mass fraction in 1a
+
+    REAL(wp), DIMENSION(nbins_aerosol) ::  core   !< size of the bin mid aerosol particle
+
+    REAL(wp), DIMENSION(0:1,ks:ke,is:ie,1:nbins_aerosol) ::  to_nconc                   !<
+    REAL(wp), DIMENSION(0:1,ks:ke,is:ie,1:nbins_aerosol*ncomponents_mass) ::  to_mconc  !<
+
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mf2a !< Mass distributions for a
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mf2b !< and b bins
+
+!
+!-- Variable name for insoluble mass fraction
+    varname_b = varname_a(1:LEN( TRIM( varname_a ) ) - 1 ) // 'b'
+!
+!-- Bin mean aerosol particle volume (m3)
+    core(1:nbins_aerosol) = api6 * aero(1:nbins_aerosol)%dmid**3
+!
+!-- Allocate and read mass fraction arrays
+    ALLOCATE( mf2a(0:1,ks:ke,is:ie,1:salsa_nest_offl%ncc),                                         &
+              mf2b(0:1,ks:ke,is:ie,1:salsa_nest_offl%ncc) )
+    IF ( ibound == 5 )  THEN
+       CALL get_variable( salsa_nest_offl%id_dynamic, varname_a,                                   &
+                          mf2a(0:1,ks:ke,is:ie,1:salsa_nest_offl%ncc), 0, salsa_nest_offl%ncc-1,   &
+                          is, ie, ks, ke, ts, te )
+    ELSE
+       CALL get_variable( salsa_nest_offl%id_dynamic, varname_a,                                   &
+                          mf2a(0:1,ks:ke,is:ie,1:salsa_nest_offl%ncc), 0, salsa_nest_offl%ncc-1,   &
+                          is, ie, ks-1, ke-1, ts, te )
+    ENDIF
+!
+!-- If the chemical component is not activated, set its mass fraction to 0 to avoid mass inbalance
+    cc_i2m = salsa_nest_offl%cc_in2mod
+    IF ( index_so4 < 0  .AND. cc_i2m(1) > 0 )  mf2a(:,:,:,cc_i2m(1)) = 0.0_wp
+    IF ( index_oc < 0   .AND. cc_i2m(2) > 0 )  mf2a(:,:,:,cc_i2m(2)) = 0.0_wp
+    IF ( index_bc < 0   .AND. cc_i2m(3) > 0 )  mf2a(:,:,:,cc_i2m(3)) = 0.0_wp
+    IF ( index_du < 0   .AND. cc_i2m(4) > 0 )  mf2a(:,:,:,cc_i2m(4)) = 0.0_wp
+    IF ( index_ss < 0   .AND. cc_i2m(5) > 0 )  mf2a(:,:,:,cc_i2m(5)) = 0.0_wp
+    IF ( index_no < 0   .AND. cc_i2m(6) > 0 )  mf2a(:,:,:,cc_i2m(6)) = 0.0_wp
+    IF ( index_nh < 0   .AND. cc_i2m(7) > 0 )  mf2a(:,:,:,cc_i2m(7)) = 0.0_wp
+    mf2b = 0.0_wp
+!
+!-- Initialise variable type_so4_oc to indicate whether SO4 and/OC is included in mass fraction data
+    IF ( ( cc_i2m(1) > 0  .AND.  index_so4 > 0 )  .AND. ( cc_i2m(2) > 0  .AND.  index_oc > 0 ) )   &
+    THEN
+       type_so4_oc = 1
+    ELSEIF ( cc_i2m(1) > 0  .AND.  index_so4 > 0 )  THEN
+       type_so4_oc = 2
+    ELSEIF ( cc_i2m(2) > 0  .AND.  index_oc > 0 )  THEN
+       type_so4_oc = 3
+    ENDIF
+
+    SELECT CASE ( ibound )
+       CASE( 1 )
+          to_nconc = salsa_nest_offl%nconc_left
+          to_mconc = salsa_nest_offl%mconc_left
+       CASE( 2 )
+          to_nconc = salsa_nest_offl%nconc_right
+          to_mconc = salsa_nest_offl%mconc_right
+       CASE( 3 )
+          to_nconc = salsa_nest_offl%nconc_north
+          to_mconc = salsa_nest_offl%mconc_north
+       CASE( 4 )
+          to_nconc = salsa_nest_offl%nconc_south
+          to_mconc = salsa_nest_offl%mconc_south
+       CASE( 5 )
+          to_nconc = salsa_nest_offl%nconc_top
+          to_mconc = salsa_nest_offl%mconc_top
+    END SELECT
+!
+!-- Set mass concentrations:
+!
+!-- Regime 1:
+    SELECT CASE ( type_so4_oc )
+       CASE ( 1 )  ! Both SO4 and OC given
+
+          ss = ( index_so4 - 1 ) * nbins_aerosol + start_subrange_1a  ! start
+          ee = ( index_so4 - 1 ) * nbins_aerosol + end_subrange_1a    ! end
+          ib = start_subrange_1a
+          DO  ic = ss, ee
+             DO i = is, ie
+                DO k = ks, ke
+                   DO t = 0, 1
+                      pmf1a = mf2a(t,k,i,cc_i2m(1)) / ( mf2a(t,k,i,cc_i2m(1)) + mf2a(t,k,i,cc_i2m(2)) )
+                      to_mconc(t,k,i,ic) = pmf1a * to_nconc(t,k,i,ib) * core(ib) * arhoh2so4
+                   ENDDO
+                ENDDO
+             ENDDO
+             ib = ib + 1
+          ENDDO
+          ss = ( index_oc - 1 ) * nbins_aerosol + start_subrange_1a ! start
+          ee = ( index_oc - 1 ) * nbins_aerosol + end_subrange_1a   ! end
+          ib = start_subrange_1a
+          DO  ic = ss, ee
+             DO i = is, ie
+                DO k = ks, ke
+                   DO t = 0, 1
+                      pmf1a = mf2a(t,k,i,cc_i2m(2)) / ( mf2a(t,k,i,cc_i2m(1)) + mf2a(t,k,i,cc_i2m(2)) )
+                      to_mconc(t,k,i,ic) = pmf1a * to_nconc(t,k,i,ib) * core(ib) * arhooc
+                   ENDDO
+                ENDDO
+             ENDDO
+             ib = ib + 1
+          ENDDO
+       CASE ( 2 )  ! Only SO4
+          ss = ( index_so4 - 1 ) * nbins_aerosol + start_subrange_1a  ! start
+          ee = ( index_so4 - 1 ) * nbins_aerosol + end_subrange_1a    ! end
+          ib = start_subrange_1a
+          DO  ic = ss, ee
+             DO i = is, ie
+                DO k = ks, ke
+                   DO t = 0, 1
+                      to_mconc(t,k,i,ic) = to_nconc(t,k,i,ib) * core(ib) * arhoh2so4
+                   ENDDO
+                ENDDO
+             ENDDO
+             ib = ib + 1
+          ENDDO
+       CASE ( 3 )  ! Only OC
+          ss = ( index_oc - 1 ) * nbins_aerosol + start_subrange_1a ! start
+          ee = ( index_oc - 1 ) * nbins_aerosol + end_subrange_1a   ! end
+          ib = start_subrange_1a
+          DO  ic = ss, ee
+             DO i = is, ie
+                DO k = ks, ke
+                   DO t = 0, 1
+                      to_mconc(t,k,i,ic) = to_nconc(t,k,i,ib) * core(ib) * arhooc
+                   ENDDO
+                ENDDO
+             ENDDO
+             ib = ib + 1
+          ENDDO
+    END SELECT
+!
+!-- Regimes 2a and 2b:
+    IF ( index_so4 > 0 ) THEN
+       CALL set_nest_mass( index_so4, 1, arhoh2so4 )
+    ENDIF
+    IF ( index_oc > 0 ) THEN
+       CALL set_nest_mass( index_oc, 2, arhooc )
+    ENDIF
+    IF ( index_bc > 0 ) THEN
+       CALL set_nest_mass( index_bc, 3, arhobc )
+    ENDIF
+    IF ( index_du > 0 ) THEN
+       CALL set_nest_mass( index_du, 4, arhodu )
+    ENDIF
+    IF ( index_ss > 0 ) THEN
+       CALL set_nest_mass( index_ss, 5, arhoss )
+    ENDIF
+    IF ( index_no > 0 ) THEN
+       CALL set_nest_mass( index_no, 6, arhohno3 )
+    ENDIF
+    IF ( index_nh > 0 ) THEN
+       CALL set_nest_mass( index_nh, 7, arhonh3 )
+    ENDIF
+
+    DEALLOCATE( mf2a, mf2b )
+
+    SELECT CASE ( ibound )
+       CASE( 1 )
+          salsa_nest_offl%mconc_left = to_mconc
+       CASE( 2 )
+          salsa_nest_offl%mconc_right = to_mconc
+       CASE( 3 )
+          salsa_nest_offl%mconc_north = to_mconc
+       CASE( 4 )
+          salsa_nest_offl%mconc_south = to_mconc
+       CASE( 5 )
+          salsa_nest_offl%mconc_top = to_mconc
+    END SELECT
+
+    CONTAINS
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Set nesting boundaries for aerosol mass.
+!------------------------------------------------------------------------------!
+    SUBROUTINE set_nest_mass( ispec, ispec_def, prho )
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  ic   !< chemical component index: default
+       INTEGER(iwp) ::  icc  !< loop index: mass bin
+
+       INTEGER(iwp), INTENT(in) ::  ispec      !< aerosol species index
+       INTEGER(iwp), INTENT(in) ::  ispec_def  !< default aerosol species index
+
+       REAL(wp), INTENT(in) ::  prho !< aerosol density
+!
+!--    Define the index of the chemical component in the input data
+       ic = salsa_nest_offl%cc_in2mod(ispec_def)
+
+       DO i = is, ie
+          DO k = ks, ke
+             DO t = 0, 1
+!
+!--             Regime 2a:
+                ss = ( ispec - 1 ) * nbins_aerosol + start_subrange_2a
+                ee = ( ispec - 1 ) * nbins_aerosol + end_subrange_2a
+                ib = start_subrange_2a
+                DO icc = ss, ee
+                   to_mconc(t,k,i,icc) = MAX( 0.0_wp, mf2a(t,k,i,ic) / SUM( mf2a(t,k,i,:) ) ) *    &
+                                         to_nconc(t,k,i,ib) * core(ib) * prho
+                   ib = ib + 1
+                ENDDO
+!
+!--             Regime 2b:
+                IF ( .NOT. no_insoluble )  THEN
+!
+!--                 TODO!
+                    mf2b(t,k,i,ic) = mf2b(t,k,i,ic)
+                ENDIF
+             ENDDO   ! k
+
+          ENDDO   ! j
+       ENDDO   ! i
+
+    END SUBROUTINE set_nest_mass
+
+ END SUBROUTINE nesting_offl_aero_mass
+
+
  END MODULE salsa_mod
